// TestDPAPI.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <vector>

#pragma comment(lib, "Crypt32.lib")

std::vector<unsigned char> encrypt_mem(const void* p, size_t size)
{
	HRESULT hr = S_OK;
	unsigned char* pEncrypt = NULL;
	std::vector<unsigned char> encrypted;

	size_t block_size = (size + (CRYPTPROTECTMEMORY_BLOCK_SIZE - 1)) 
			& ~(CRYPTPROTECTMEMORY_BLOCK_SIZE - 1);

	encrypted.resize(block_size);

	memcpy(&encrypted[0], p, size);
	
	if (!CryptProtectMemory(&encrypted[0], encrypted.size(),
		CRYPTPROTECTMEMORY_SAME_LOGON))
	{
		wprintf(L"CryptProtectMemory failed: %d\n", GetLastError());
		encrypted.resize(0);
	}

	return encrypted;
}

#define TEXT_ L"Hello"

bool DoCaptureToken(HANDLE* ptoken);

HANDLE GetAdminToken()
{
	HANDLE ret = nullptr;
	bool success = false;

	CoInitialize(NULL);

	success = DoCaptureToken(&ret);

	CoUninitialize();

	if (success)
	{
		return ret;
	}
	else
	{
		return nullptr;
	}
}

void test_cryptmem()
{
	HANDLE linked_token = GetAdminToken();
	std::vector<unsigned char> logon_a;
	std::vector<unsigned char> logon_b;

	if (linked_token)
	{
		logon_a = encrypt_mem(TEXT_, sizeof(TEXT_));

		if (ImpersonateLoggedOnUser(linked_token))
		{
			logon_b = encrypt_mem(TEXT_, sizeof(TEXT_));
			RevertToSelf();

			if (memcmp(&logon_a[0], &logon_b[0], logon_a.size()))
			{
				printf("Encryption doesn't match, impersonated session?\n");
			}
			else
			{
				printf("Encryption matches, impersonation failed\n");
			}
		}
		else
		{
			printf("Error impersonating %d\n", GetLastError());
		}
	}
}

int wmain(int argc, wchar_t** argv)
{
	test_cryptmem();
}